// tall1.cpp   Testet alles auf WEB1              04.07.2002
//             Test LCD Init und Ausgabe          03.07.2002
//             Test Ausgabe und Eingabe           05.07.2002
//             Test                               16.01.2004
 
// includes    
#pragma -1                 // Code fuer 286

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

// Definitionen
//------------- 
#define  DOS_INT  0x21     // Interrupts  
#define  HAL_INT  0xA1           
#define  PFE_INT  0xA2
#define  CGI_INT  0xAB     // CGI
#define  TCP_INT  0xAC
#define  DOS_INT  0x21

   #define portadr1 0x100  //  Dig.Port 1  WEB1 und WEB2
   #define portadr2 0x101  //           2  WEB1
   #define lcdcom1  0x102  //  LCD-Anzeige WEB1
   #define lcddat1  0x103
// #define lcdcom1  0x200  //              WEB2 oben 
// #define lcddat1  0x201                                
   #define lcdcom2  0x300  //              WEB2 unten
   #define lcddat2  0x301

//   Prototypen
//   ----------

// globale Variablen
// -----------------

static union    REGS  inregs;               // C-SoftInterrupt-Funktion
static union    REGS  outregs;
static struct   SREGS segregs;

char *progname = "tall1.exe";

void port_out( int portadr, unsigned char ausgabe )
//   --------
// schreibt in die Ausgabepins O0-O7 den Wert 'ausgabe'
{
   inregs.h.ah = 0x81;                      // SoftINT: A1h, Fkt: 81h
   inregs.x.di = portadr;                   // Adresse ausgeben
   inregs.h.dh = 0;
   inregs.h.dl = ausgabe;
   inregs.x.bx = 0xFFFF;                    // wAND=0xFFFF
   inregs.x.cx = 0x0000;                    // wXOR=0x0000
   int86x(HAL_INT, &inregs, &outregs, &segregs);
}

unsigned char port_in( int portadr )
//            -------
// Liest die Zustaende an Port portadr
{
  inregs.h.ah = 0x80;                       // SoftINT A1  Fkt 80
  inregs.x.di = portadr;                    // an Adresse ausgeben                                        // geaendert Lamken
  inregs.x.bx = 0xFFFF;                     // wAND=0xFFFF
  inregs.x.cx = 0x0000;                     // wXOR=0x0000
  int86x(HAL_INT, &inregs, &outregs, &segregs);
  return outregs.h.al;
}

void sleepw (int msec)
//   ------
// veranlasst eine Wartezeit, die in msec angegeben wird.
{
   inregs.h.ah = 0x09;                  // SoftINT: ACh, Fkt: 09h
   inregs.x.bx = msec;
   int86x(TCP_INT, &inregs, &outregs, &segregs);
}


void lcd_wait()
//   --------
{
// warten msec millisekunden
   int msec = 1;
   inregs.h.ah = 0x09;       // SoftINT: ACh, Fkt: 09h
   inregs.x.bx = msec;
   int86x(TCP_INT, &inregs, &outregs, &segregs);
}

void lcd_init ( unsigned char anzeige )
//   --------
{
   int data, lcdcom;
   if (anzeige == 1 ) { lcdcom = lcdcom1; }
   if (anzeige == 2 ) { lcdcom = lcdcom2; }

   data = 0x38;       // 00111000 init 8 bit 2 Zeilen Zeichensatz 5*10
   port_out (lcdcom , data);  lcd_wait();
   data = 0x0c;       // 00001100 Display 1 Cursor 0 Blink 0
   port_out (lcdcom , data);  lcd_wait();
   data = 0x06;       // 0000110 Modus verschieben rechts ohne Text
   port_out (lcdcom , data);  lcd_wait();
   data = 0x01;       // 0000001 Anzeige loeschen
   port_out (lcdcom , data);  lcd_wait();
}

void lcd_write ( unsigned char anzeige, unsigned char x, unsigned char y, char * text )
//   ---------
{
   int data, lcdcom, lcddat ;
   unsigned char pos;  // 0,0 = 80h  0,1 = C0h
   if (anzeige == 1 ) { lcdcom = lcdcom1; lcddat = lcddat1; }
   if (anzeige == 2 ) { lcdcom = lcdcom2; lcddat = lcddat2; }

   pos = 128 +  (( y%2 ) * 64 ) + ( x%40 ) ;
   port_out (lcdcom , pos );  lcd_wait();
   while ( *text!='\0')
      { port_out (lcddat , *text++); lcd_wait(); }
}

int main(void)
//  ----
{
   int       i, portadr, max, dein, imax ;
   int       j, maxj ;
  
   char      text1[200], text2[200] ;   // Text fuer Ausgabe
   char      zeile1[41], zeile2[41] ;   // Text fuer LCD-Anzeige
   char      textaus[20];

   j = 0; maxj = 10;
   do
   {
      // Test der Ausgabe
                  
      strcpy(textaus, "bin. Ausgabe");
      portadr = portadr1 ;             // Auswahl des Ports
      printf("\n Programm %s : Ausgabe auf Portadr: %xh = %s", progname, portadr, textaus ) ;
      // alles aus/an/aus
      port_out(portadr, 0x00 );   // alles aus
      sleepw(100);
      port_out(portadr, 0xff );   // alles an
      sleepw(100);
      port_out(portadr, 0x00 );   // alles aus
      sleepw(100);
      // binaer zaehlen
      i = 0; max = 255;
      while ( i < max )
      {  port_out( portadr , i ) ;
         sleepw(10) ;
         i++;
      }
      port_out(portadr, 0x00 );   // alles aus
      sleepw(100);

      // Test der Eingabe
                  
      strcpy(textaus, "bin. Eingabe");
      portadr = portadr1 ;             // Auswahl des Ports
      printf("\n Programm %s : Ausgabe auf Portadr: %xh = %s", progname, portadr, textaus ) ;

      i = 0; max = 255;
      while ( i < max )
      {  
         dein = port_in( portadr ) ;
         printf("\n %4i. eingelesen: %xh ", i, dein );
         sleepw( 10 ) ;
         i++;
      }

      // Test der LCD-Anzeigen
                  
      strcpy(textaus, "LCD 1 oben");
      portadr = lcdcom1;             // Auswahl des Ports
      printf("\n Programm %s : Ausgabe auf Portadr: %xh = %s", progname, portadr, textaus ) ;

      lcd_init(1);
      i = 0; max = 40;
      while ( i < max )
      {
         lcd_write(1,i,0,"A");
         lcd_write(1,i,1,"1");
         i++;
      }
      sleepw(1000);
      lcd_init(1);
/*              
      strcpy(textaus, "LCD 2 unten");
      portadr = lcdcom2;             // Auswahl des Ports
      printf("\n Programm %s : Ausgabe auf Portadr: %xh = %s", progname, portadr, textaus ) ;

      lcd_init(2);
      i = 0; max = 16;
      while ( i < max )
      {
         lcd_write(2,i,0,"B");
         lcd_write(2,i,1,"2");
         i++;
      }
      sleepw(1000);
      lcd_init(2);
*/
      j++;
   } while (j < maxj ) ; 

   printf("\n Ende von %s \n", progname);
   return 0;
}