// tlcd1.cpp   Test AUSgabe auf LCD-Anzeige    25.06.2002
//             Test LCD Init und Ausgabe       02.07.2002
//             Test                            16.01.2004

// includes    
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>

// Definitionen
//------------- 
#define  DOS_INT  0x21           // Interrupts  
#define  HAL_INT  0xA1           
#define  PFE_INT  0xA2
#define  CGI_INT  0xAB           // CGI
#define  TCP_INT  0xAC
#define  DOS_INT  0x21

   #define port1adr 0x100  //  Dig.Port 1  WEB1 und WEB2
   #define port2adr 0x101  //           2  WEB1
   #define lcdcom   0x102  //  LCD-Anzeige WEB1
   #define lcddat   0x103
// #define lcdcom   0x200  //              WEB2 oben 
// #define lcddat   0x201                                
// #define lcdcom   0x300  //              WEB2 unten
// #define lcddat   0x301

//   Prototypen
//   ----------
void outportb(int portid, unsigned char value);
void port_out( int portadr, unsigned char ausgabe);

// globale Variablen
// -----------------

static union    REGS  inregs;               // C-SoftInterrupt-Funktion
static union    REGS  outregs;
static struct   SREGS segregs;


void lcd_wait()
{
// warten msec millisekunden
   int msec = 100;
   inregs.h.ah = 0x09;       // SoftINT: ACh, Fkt: 09h
   inregs.x.bx = msec;
   int86x(TCP_INT, &inregs, &outregs, &segregs);
}

void lcd_init()
{
   int data;

   data = 0x38;             // 00111000 init 8 bit 2 Zeilen Zeichensatz 5*10
   outportb (lcdcom , data); 
   lcd_wait();
   printf("\n Port : %2xh Daten : %02Xh", lcdcom, data ); 
   data = 0x0c;             // 00001100 Display 1 Cursor 0 Blink 0
   outportb (lcdcom , data); 
   lcd_wait();
   printf("\n Port : %2xh Daten : %02Xh", lcdcom, data ); 
   data = 0x06;             // 0000110 Modus verschieben rechts ohne Text
   outportb (lcdcom , data); 
   lcd_wait();
   printf("\n Port : %2xh Daten : %02Xh", lcdcom, data ); 
   data = 0x01;             // Anzeige loeschen
   outportb (lcdcom , data); 
   lcd_wait();
   printf("\n Port : %2xh Daten : %02Xh", lcdcom, data ); 
}

void lcd_write ( unsigned char x, unsigned char y, char * text )
{
   unsigned char pos;
   pos = 128 +  (( y%2 ) * 64 ) + ( x%32 ) ;
   outportb ( lcdcom, pos ) ;
   printf("\n Port : %2xh Daten : %2xh", lcdcom, pos    ); 
   lcd_wait();
   while ( *text!='\0')
      { 
        printf("\n Port : %2xh Text  : %02Xh", lcddat, *text); 
        outportb ( lcddat, *text++); 
        lcd_wait(); 
      }
}

//* main ****** Hauptprogramm **********************************              
int main(void)
{
   int       i, portadr, max, imax ;
   int       j, maxj ;

   portadr = lcdcom;             // Auswahl des Ports   

   printf("\n Programm tlcd1 testet Ausgabe auf Port adr: %x ", portadr ) ;

   // Test des LCD 

   i = 0; max = 2;
   while ( i < max )
   {
      lcd_init();
      lcd_write(0,0,"abc");
      lcd_write(0,1,"123");
      i++; 
   }
   printf("\n Ende \n");

   return 0;
}