// tlcd3.cpp   3. Test AUSgabe auf LCD-Anzeige   25.06.2002
//             Test LCD Init und Ausgabe         03.07.2002
//             Test                              16.01.2004
 
// includes    
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>

// Definitionen
//------------- 
#define  DOS_INT  0x21     // Interrupts  
#define  HAL_INT  0xA1           
#define  PFE_INT  0xA2
#define  CGI_INT  0xAB     // CGI
#define  TCP_INT  0xAC
#define  DOS_INT  0x21

   #define port1adr 0x100  //  Dig.Port 1  WEB1 und WEB2
   #define port2adr 0x101  //           2  WEB1
   #define lcdcom1  0x102  //  LCD-Anzeige WEB1
   #define lcddat1  0x103
// #define lcdcom1  0x200  //              WEB2 oben 
// #define lcddat1  0x201                                
   #define lcdcom2  0x300  //              WEB2 unten
   #define lcddat2  0x301

//   Prototypen
//   ----------

// globale Variablen
// -----------------

static union    REGS  inregs;               // C-SoftInterrupt-Funktion
static union    REGS  outregs;
static struct   SREGS segregs;


void port_out( int portadr, unsigned char ausgabe)
//   --------
// schreibt in die Ausgabepins O0-O7 den Wert 'ausgabe'
{
   inregs.h.ah = 0x81;                      // SoftINT: A1h, Fkt: 81h
   inregs.x.di = portadr;                   // Adresse ausgeben
   inregs.h.dh = 0;
   inregs.h.dl = ausgabe;
   inregs.x.bx = 0xFFFF;                    // wAND=0xFFFF
   inregs.x.cx = 0x0000;                    // wXOR=0x0000
   int86x(HAL_INT, &inregs, &outregs, &segregs);
}


void lcd_wait( )
{
// warten msec millisekunden
   int msec = 1;
   inregs.h.ah = 0x09;       // SoftINT: ACh, Fkt: 09h
   inregs.x.bx = msec;
   int86x(TCP_INT, &inregs, &outregs, &segregs);
}

void lcd_init( unsigned char anzeige )
{
   int data, lcdcom;
   if (anzeige == 1 ) { lcdcom = lcdcom1; }
   if (anzeige == 2 ) { lcdcom = lcdcom2; }

   data = 0x38;       // 00111000 init 8 bit 2 Zeilen Zeichensatz 5*10
   port_out (lcdcom , data);  lcd_wait();
   data = 0x0c;       // 00001100 Display 1 Cursor 0 Blink 0
   port_out (lcdcom , data);  lcd_wait();
   data = 0x06;       // 0000110 Modus verschieben rechts ohne Text
   port_out (lcdcom , data);  lcd_wait();
   data = 0x01;       // 0000001 Anzeige loeschen
   port_out (lcdcom , data);  lcd_wait();
}

void lcd_write ( unsigned char anzeige, unsigned char x, unsigned char y, char * text )
{
   int data, lcdcom, lcddat ;
   unsigned char pos;  // 0,0 = 80h  0,1 = C0h
   if (anzeige == 1 ) { lcdcom = lcdcom1; lcddat = lcddat1; }
   if (anzeige == 2 ) { lcdcom = lcdcom2; lcddat = lcddat2; }

   pos = 128 +  (( y%2 ) * 64 ) + ( x%40 ) ;
// printf("\n Port : %2xh Daten : %2xh", lcdcom, pos    ); 
   port_out (lcdcom , pos );  lcd_wait();
   while ( *text!='\0')
      { port_out (lcddat , *text++); lcd_wait(); }
}

int main(void)
{
   int       i, portadr, max, imax ;
   int       j, maxj ;
  
   char      text1[200], text2[200] ;   // Text fuer Ausgabe
   char      zeile1[41], zeile2[41] ;   // Text fuer LCD-Anzeige

   portadr = lcdcom1;             // Auswahl des Ports

   printf("\n Programm tlcd3 testet Ausgabe auf Port adr: %x ", portadr ) ;

   // Test der LCD-Anzeige 
   lcd_init(1);
// lcd_init(2);                   // nur WEB2

   i = 0; 
// max = 40;                      // nur WEB2
   max = 15;
   while ( i < max )
   {
      lcd_write(1,i,0,"A");
      lcd_write(1,i,1,"1");      
      i++;
   }
   i = 0; max = 16;
   while ( i < max )
   {
//    lcd_write(2,i,0,"B");       // nur WEB2
//    lcd_write(2,i,1,"2");       // nur WEB2
      i++;
   }
   printf("\n Ende \n");

   return 0;
}